import java.io.*;
import java.util.*;
//--------------------------------------------------------------------------------------------
class Coords {
   double x;
   double y;
   public Coords( double x, double y ) {
      this.x = x;
      this.y = y;
   }
   public String toString() {
      return "<" + x + ";" + y + ">";
   }
}
//--------------------------------------------------------------------------------------------
class Container extends HashMap<String,Coords> {
   private boolean ok;
   private void parse( String line ) {
      Scanner scan = new Scanner( line );
      scan.useDelimiter( "," );
      String code = "";
      double x = 0, y = 0;
      if( scan.hasNext() ) code = scan.next();
      if( scan.hasNext() ) x = new Double( scan.next() ).doubleValue();
      if( scan.hasNext() ) y = new Double( scan.next() ).doubleValue();
      scan.close();
      put( code, new Coords( x, y) );
   }
   public Container( String fdata, String ftmp ) {
      ok = false;
      BufferedReader bd = null, bt = null;
      try {		
         bd = new BufferedReader( new FileReader( fdata ) );
         String curline = "";
         while( ( curline = bd.readLine() ) != null ) {
            if( curline.length() == 0 || '#' == curline.charAt( 0 ) ) continue;
            bt = new BufferedReader( new FileReader( ftmp ) );
            String template = "";
            while( ( template = bt.readLine() ) != null ) {
               if( template.length() == 0 || '#' == template.charAt( 0 ) ) continue;
               if( curline.startsWith( template ) )             
                  parse( curline );
            }
            try { bt.close(); } catch( IOException e ) {}
         }
         ok = true;
      } catch( FileNotFoundException e ) {
         System.out.println( "no such file" );
      } catch( IOException e ) {
         System.out.println( "IO error" );
      }
      finally {
         try {
            if( null != bd ) bd.close();
            if( null != bt ) bt.close();
         } catch( IOException e ) {}
      } 
   }
   public boolean ok() { return ok; }
   public String toString() {
      Set<Map.Entry<String,Coords>> set = entrySet();
      String res = new String( "[" );
      for( Map.Entry<String,Coords> e : set ) 
         res += " '" + e.getKey() + "'" + e.getValue();
      return res + " ]";
   }
}
//--------------------------------------------------------------------------------------------
class postalCodeParser {

   public static void main( String args[] ) {
      if( args.length != 2 ) {
         System.out.println( "usage: $ java postalCodeParser <data_filename> <template_filename>" );
         return;
      }
      Container table = new Container( args[ 0 ], args[ 1 ] );
      if( !table.ok() ) {
         System.out.println( "ошибка заполнения контейнера!" );
         System.exit( 1 );
      }
      else 
         System.out.println( table.size() + " записей : \n" + table );
   }
}

